Index: branches/HeuristicLab.Mono/HeuristicLab.ExtLibs/HeuristicLab.WinFormsUI/2.3.1/HeuristicLab.WinFormsUI-2.3.1/Plugin.cs.frame
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.ExtLibs/HeuristicLab.WinFormsUI/2.3.1/HeuristicLab.WinFormsUI-2.3.1/Plugin.cs.frame	(revision 8445)
+++ branches/HeuristicLab.Mono/HeuristicLab.ExtLibs/HeuristicLab.WinFormsUI/2.3.1/HeuristicLab.WinFormsUI-2.3.1/Plugin.cs.frame	(revision 8446)
@@ -10,5 +10,5 @@
   [PluginFile("HeuristicLab.WinFormsUI-2.3.1.dll", PluginFileType.Assembly)]
   [PluginFile("WeifenLuo.WinFormsUI.Docking-2.3.1.dll", PluginFileType.Assembly)]
-  [PluginFile("WeifenLuo.WinformsUI.Docking License.txt",PluginFileType.License)]
+  [PluginFile("WeifenLuo.WinFormsUI.Docking License.txt",PluginFileType.License)]
   public class HeuristicLabWinFormsUIPlugin : PluginBase {
   }
Index: branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/DeSerializer.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/DeSerializer.cs	(revision 8445)
+++ 	(revision )
@@ -1,262 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using HeuristicLab.Persistence.Auxiliary;
-using HeuristicLab.Persistence.Core.Tokens;
-using HeuristicLab.Persistence.Interfaces;
-
-namespace HeuristicLab.Persistence.Core {
-
-  /// <summary>
-  /// Core hub for deserialization. Reads the serialization token stream,
-  /// instantiates objects and fills in values.
-  /// </summary>
-  public class Deserializer {
-
-    /// <summary>
-    /// Helps in delivering the class instance and acts as proxy while
-    /// the object cannot yet be instantiate.
-    /// </summary>
-    private class Midwife {
-
-      public int? Id { get; private set; }
-      public bool MetaMode { get; set; }
-      public object Obj { get; private set; }
-
-      private List<Tag> metaInfo;
-      private List<Tag> customValues;
-      private Type type;
-      private ICompositeSerializer compositeSerializer;
-
-      public Midwife(object value) {
-        this.Obj = value;
-      }
-
-      public Midwife(Type type, ICompositeSerializer compositeSerializer, int? id) {
-        this.type = type;
-        this.compositeSerializer = compositeSerializer;
-        this.Id = id;
-        MetaMode = false;
-        metaInfo = new List<Tag>();
-        customValues = new List<Tag>();
-      }
-
-      public void CreateInstance() {
-        if (Obj != null)
-          throw new PersistenceException("object already instantiated");
-        Obj = compositeSerializer.CreateInstance(type, metaInfo);
-      }
-
-      public void AddValue(string name, object value) {
-        if (MetaMode) {
-          metaInfo.Add(new Tag(name, value));
-        } else {
-          customValues.Add(new Tag(name, value));
-        }
-      }
-
-      public void Populate() {
-        compositeSerializer.Populate(Obj, customValues, type);
-      }
-    }
-
-    private readonly Dictionary<int, object> id2obj;
-    private readonly Dictionary<Type, object> serializerMapping;
-    private readonly Stack<Midwife> parentStack;
-    private readonly Dictionary<int, Type> typeIds;
-    private Dictionary<Type, object> serializerInstances;
-
-    /// <summary>
-    /// Instantiates a new deserializer with the given type cache,
-    /// that contains information about the serializers to use
-    /// for every type and their type ids.
-    /// </summary>
-    /// <param name="typeCache">The type cache.</param>
-    public Deserializer(
-      IEnumerable<TypeMapping> typeCache) {
-      id2obj = new Dictionary<int, object>();
-      parentStack = new Stack<Midwife>();
-      typeIds = new Dictionary<int, Type>();
-      serializerMapping = new Dictionary<Type, object>();
-      serializerInstances = new Dictionary<Type, object>();
-      foreach (var typeMapping in typeCache) {
-        AddTypeInfo(typeMapping);
-      }
-    }
-
-    /// <summary>
-    /// Adds additionaly type information.
-    /// </summary>
-    /// <param name="typeMapping">The new type mapping.</param>
-    public void AddTypeInfo(TypeMapping typeMapping) {
-      if (typeIds.ContainsKey(typeMapping.Id))
-        return;
-      try {
-        Type type = TypeLoader.Load(typeMapping.TypeName);
-        typeIds.Add(typeMapping.Id, type);
-        Type serializerType = TypeLoader.Load(typeMapping.Serializer);
-        object serializer;
-        if (serializerInstances.ContainsKey(serializerType)) {
-          serializer = serializerInstances[serializerType];
-        } else {
-          serializer = Activator.CreateInstance(serializerType, true);
-          serializerInstances.Add(serializerType, serializer);
-        }
-        serializerMapping.Add(type, serializer);
-      } catch (PersistenceException) {
-        throw;
-      } catch (Exception e) {
-        throw new PersistenceException(string.Format(
-          "Could not add type info for {0} ({1})",
-          typeMapping.TypeName, typeMapping.Serializer), e);
-      }
-    }
-
-    /// <summary>
-    /// Process the token stream and deserialize an instantate a new object graph.
-    /// </summary>
-    /// <param name="tokens">The tokens.</param>
-    /// <returns>A fresh object filled with fresh data.</returns>
-    public object Deserialize(IEnumerable<ISerializationToken> tokens) {
-      foreach (ISerializationToken token in tokens) {
-        Type t = token.GetType();
-        if (t == typeof(BeginToken)) {
-          CompositeStartHandler((BeginToken)token);
-        } else if (t == typeof(EndToken)) {
-          CompositeEndHandler((EndToken)token);
-        } else if (t == typeof(PrimitiveToken)) {
-          PrimitiveHandler((PrimitiveToken)token);
-        } else if (t == typeof(ReferenceToken)) {
-          ReferenceHandler((ReferenceToken)token);
-        } else if (t == typeof(NullReferenceToken)) {
-          NullHandler((NullReferenceToken)token);
-        } else if (t == typeof(MetaInfoBeginToken)) {
-          MetaInfoBegin((MetaInfoBeginToken)token);
-        } else if (t == typeof(MetaInfoEndToken)) {
-          MetaInfoEnd((MetaInfoEndToken)token);
-        } else if (t == typeof(TypeToken)) {
-          Type((TypeToken)token);
-        } else {
-          throw new PersistenceException("invalid token type");
-        }
-      }
-      return parentStack.Pop().Obj;
-    }
-
-    private void InstantiateParent() {
-      if (parentStack.Count == 0)
-        return;
-      Midwife m = parentStack.Peek();
-      if (!m.MetaMode && m.Obj == null)
-        CreateInstance(m);
-    }
-
-    private void Type(TypeToken token) {
-      AddTypeInfo(new TypeMapping(token.Id, token.TypeName, token.Serializer));
-    }
-
-    private void CompositeStartHandler(BeginToken token) {
-      InstantiateParent();
-      Type type = typeIds[(int)token.TypeId];
-      try {
-        parentStack.Push(new Midwife(type, (ICompositeSerializer)serializerMapping[type], token.Id));
-      } catch (Exception e) {
-        if (e is InvalidCastException || e is KeyNotFoundException) {
-          throw new PersistenceException(String.Format(
-            "Invalid composite serializer configuration for type \"{0}\".",
-            type.AssemblyQualifiedName), e);
-        } else {
-          throw new PersistenceException(String.Format(
-            "Unexpected exception while trying to compose object of type \"{0}\".",
-            type.AssemblyQualifiedName), e);
-        }
-      }
-    }
-
-    private void CompositeEndHandler(EndToken token) {
-      Type type = typeIds[(int)token.TypeId];
-      Midwife midwife = parentStack.Pop();
-      if (midwife.Obj == null)
-        CreateInstance(midwife);
-      midwife.Populate();
-      SetValue(token.Name, midwife.Obj);
-    }
-
-    private void PrimitiveHandler(PrimitiveToken token) {
-      Type type = typeIds[(int)token.TypeId];
-      try {
-        object value = ((IPrimitiveSerializer)serializerMapping[type]).Parse(token.SerialData);
-        if (token.Id != null)
-          id2obj[(int)token.Id] = value;
-        SetValue(token.Name, value);
-      } catch (Exception e) {
-        if (e is InvalidCastException || e is KeyNotFoundException) {
-          throw new PersistenceException(String.Format(
-            "Invalid primitive serializer configuration for type \"{0}\".",
-            type.AssemblyQualifiedName), e);
-        } else {
-          throw new PersistenceException(String.Format(
-            "Unexpected exception while trying to parse object of type \"{0}\".",
-            type.AssemblyQualifiedName), e);
-        }
-      }
-    }
-
-    private void ReferenceHandler(ReferenceToken token) {
-      object referredObject = id2obj[token.Id];
-      SetValue(token.Name, referredObject);
-    }
-
-    private void NullHandler(NullReferenceToken token) {
-      SetValue(token.Name, null);
-    }
-
-    private void MetaInfoBegin(MetaInfoBeginToken token) {
-      parentStack.Peek().MetaMode = true;
-    }
-
-    private void MetaInfoEnd(MetaInfoEndToken token) {
-      Midwife m = parentStack.Peek();
-      m.MetaMode = false;
-      CreateInstance(m);
-    }
-
-    private void CreateInstance(Midwife m) {
-      m.CreateInstance();
-      if (m.Id != null)
-        id2obj.Add((int)m.Id, m.Obj);
-    }
-
-    private void SetValue(string name, object value) {
-      if (parentStack.Count == 0) {
-        parentStack.Push(new Midwife(value));
-      } else {
-        Midwife m = parentStack.Peek();
-        if (m.MetaMode == false && m.Obj == null) {
-          CreateInstance(m);
-        }
-        m.AddValue(name, value);
-      }
-    }
-  }
-}
Index: branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Deserializer.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Deserializer.cs	(revision 8446)
+++ branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Deserializer.cs	(revision 8446)
@@ -0,0 +1,262 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Persistence.Auxiliary;
+using HeuristicLab.Persistence.Core.Tokens;
+using HeuristicLab.Persistence.Interfaces;
+
+namespace HeuristicLab.Persistence.Core {
+
+  /// <summary>
+  /// Core hub for deserialization. Reads the serialization token stream,
+  /// instantiates objects and fills in values.
+  /// </summary>
+  public class Deserializer {
+
+    /// <summary>
+    /// Helps in delivering the class instance and acts as proxy while
+    /// the object cannot yet be instantiate.
+    /// </summary>
+    private class Midwife {
+
+      public int? Id { get; private set; }
+      public bool MetaMode { get; set; }
+      public object Obj { get; private set; }
+
+      private List<Tag> metaInfo;
+      private List<Tag> customValues;
+      private Type type;
+      private ICompositeSerializer compositeSerializer;
+
+      public Midwife(object value) {
+        this.Obj = value;
+      }
+
+      public Midwife(Type type, ICompositeSerializer compositeSerializer, int? id) {
+        this.type = type;
+        this.compositeSerializer = compositeSerializer;
+        this.Id = id;
+        MetaMode = false;
+        metaInfo = new List<Tag>();
+        customValues = new List<Tag>();
+      }
+
+      public void CreateInstance() {
+        if (Obj != null)
+          throw new PersistenceException("object already instantiated");
+        Obj = compositeSerializer.CreateInstance(type, metaInfo);
+      }
+
+      public void AddValue(string name, object value) {
+        if (MetaMode) {
+          metaInfo.Add(new Tag(name, value));
+        } else {
+          customValues.Add(new Tag(name, value));
+        }
+      }
+
+      public void Populate() {
+        compositeSerializer.Populate(Obj, customValues, type);
+      }
+    }
+
+    private readonly Dictionary<int, object> id2obj;
+    private readonly Dictionary<Type, object> serializerMapping;
+    private readonly Stack<Midwife> parentStack;
+    private readonly Dictionary<int, Type> typeIds;
+    private Dictionary<Type, object> serializerInstances;
+
+    /// <summary>
+    /// Instantiates a new deserializer with the given type cache,
+    /// that contains information about the serializers to use
+    /// for every type and their type ids.
+    /// </summary>
+    /// <param name="typeCache">The type cache.</param>
+    public Deserializer(
+      IEnumerable<TypeMapping> typeCache) {
+      id2obj = new Dictionary<int, object>();
+      parentStack = new Stack<Midwife>();
+      typeIds = new Dictionary<int, Type>();
+      serializerMapping = new Dictionary<Type, object>();
+      serializerInstances = new Dictionary<Type, object>();
+      foreach (var typeMapping in typeCache) {
+        AddTypeInfo(typeMapping);
+      }
+    }
+
+    /// <summary>
+    /// Adds additionaly type information.
+    /// </summary>
+    /// <param name="typeMapping">The new type mapping.</param>
+    public void AddTypeInfo(TypeMapping typeMapping) {
+      if (typeIds.ContainsKey(typeMapping.Id))
+        return;
+      try {
+        Type type = TypeLoader.Load(typeMapping.TypeName);
+        typeIds.Add(typeMapping.Id, type);
+        Type serializerType = TypeLoader.Load(typeMapping.Serializer);
+        object serializer;
+        if (serializerInstances.ContainsKey(serializerType)) {
+          serializer = serializerInstances[serializerType];
+        } else {
+          serializer = Activator.CreateInstance(serializerType, true);
+          serializerInstances.Add(serializerType, serializer);
+        }
+        serializerMapping.Add(type, serializer);
+      } catch (PersistenceException) {
+        throw;
+      } catch (Exception e) {
+        throw new PersistenceException(string.Format(
+          "Could not add type info for {0} ({1})",
+          typeMapping.TypeName, typeMapping.Serializer), e);
+      }
+    }
+
+    /// <summary>
+    /// Process the token stream and deserialize an instantate a new object graph.
+    /// </summary>
+    /// <param name="tokens">The tokens.</param>
+    /// <returns>A fresh object filled with fresh data.</returns>
+    public object Deserialize(IEnumerable<ISerializationToken> tokens) {
+      foreach (ISerializationToken token in tokens) {
+        Type t = token.GetType();
+        if (t == typeof(BeginToken)) {
+          CompositeStartHandler((BeginToken)token);
+        } else if (t == typeof(EndToken)) {
+          CompositeEndHandler((EndToken)token);
+        } else if (t == typeof(PrimitiveToken)) {
+          PrimitiveHandler((PrimitiveToken)token);
+        } else if (t == typeof(ReferenceToken)) {
+          ReferenceHandler((ReferenceToken)token);
+        } else if (t == typeof(NullReferenceToken)) {
+          NullHandler((NullReferenceToken)token);
+        } else if (t == typeof(MetaInfoBeginToken)) {
+          MetaInfoBegin((MetaInfoBeginToken)token);
+        } else if (t == typeof(MetaInfoEndToken)) {
+          MetaInfoEnd((MetaInfoEndToken)token);
+        } else if (t == typeof(TypeToken)) {
+          Type((TypeToken)token);
+        } else {
+          throw new PersistenceException("invalid token type");
+        }
+      }
+      return parentStack.Pop().Obj;
+    }
+
+    private void InstantiateParent() {
+      if (parentStack.Count == 0)
+        return;
+      Midwife m = parentStack.Peek();
+      if (!m.MetaMode && m.Obj == null)
+        CreateInstance(m);
+    }
+
+    private void Type(TypeToken token) {
+      AddTypeInfo(new TypeMapping(token.Id, token.TypeName, token.Serializer));
+    }
+
+    private void CompositeStartHandler(BeginToken token) {
+      InstantiateParent();
+      Type type = typeIds[(int)token.TypeId];
+      try {
+        parentStack.Push(new Midwife(type, (ICompositeSerializer)serializerMapping[type], token.Id));
+      } catch (Exception e) {
+        if (e is InvalidCastException || e is KeyNotFoundException) {
+          throw new PersistenceException(String.Format(
+            "Invalid composite serializer configuration for type \"{0}\".",
+            type.AssemblyQualifiedName), e);
+        } else {
+          throw new PersistenceException(String.Format(
+            "Unexpected exception while trying to compose object of type \"{0}\".",
+            type.AssemblyQualifiedName), e);
+        }
+      }
+    }
+
+    private void CompositeEndHandler(EndToken token) {
+      Type type = typeIds[(int)token.TypeId];
+      Midwife midwife = parentStack.Pop();
+      if (midwife.Obj == null)
+        CreateInstance(midwife);
+      midwife.Populate();
+      SetValue(token.Name, midwife.Obj);
+    }
+
+    private void PrimitiveHandler(PrimitiveToken token) {
+      Type type = typeIds[(int)token.TypeId];
+      try {
+        object value = ((IPrimitiveSerializer)serializerMapping[type]).Parse(token.SerialData);
+        if (token.Id != null)
+          id2obj[(int)token.Id] = value;
+        SetValue(token.Name, value);
+      } catch (Exception e) {
+        if (e is InvalidCastException || e is KeyNotFoundException) {
+          throw new PersistenceException(String.Format(
+            "Invalid primitive serializer configuration for type \"{0}\".",
+            type.AssemblyQualifiedName), e);
+        } else {
+          throw new PersistenceException(String.Format(
+            "Unexpected exception while trying to parse object of type \"{0}\".",
+            type.AssemblyQualifiedName), e);
+        }
+      }
+    }
+
+    private void ReferenceHandler(ReferenceToken token) {
+      object referredObject = id2obj[token.Id];
+      SetValue(token.Name, referredObject);
+    }
+
+    private void NullHandler(NullReferenceToken token) {
+      SetValue(token.Name, null);
+    }
+
+    private void MetaInfoBegin(MetaInfoBeginToken token) {
+      parentStack.Peek().MetaMode = true;
+    }
+
+    private void MetaInfoEnd(MetaInfoEndToken token) {
+      Midwife m = parentStack.Peek();
+      m.MetaMode = false;
+      CreateInstance(m);
+    }
+
+    private void CreateInstance(Midwife m) {
+      m.CreateInstance();
+      if (m.Id != null)
+        id2obj.Add((int)m.Id, m.Obj);
+    }
+
+    private void SetValue(string name, object value) {
+      if (parentStack.Count == 0) {
+        parentStack.Push(new Midwife(value));
+      } else {
+        Midwife m = parentStack.Peek();
+        if (m.MetaMode == false && m.Obj == null) {
+          CreateInstance(m);
+        }
+        m.AddValue(name, value);
+      }
+    }
+  }
+}
Index: branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Tokens/NulLReferenceToken.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Tokens/NulLReferenceToken.cs	(revision 8445)
+++ 	(revision )
@@ -1,37 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-
-namespace HeuristicLab.Persistence.Core.Tokens {
-
-  /// <summary>
-  /// Describes a reference to <c>null</c>.
-  /// </summary>
-  public class NullReferenceToken : SerializationTokenBase {
-
-    /// <summary>
-    /// Initializes a new instance of the <see cref="NullReferenceToken"/> class.
-    /// </summary>
-    /// <param name="name">The token name.</param>
-    public NullReferenceToken(string name) : base(name) { }
-  }
-
-}
Index: branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Tokens/NullReferenceToken.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Tokens/NullReferenceToken.cs	(revision 8446)
+++ branches/HeuristicLab.Mono/HeuristicLab.Persistence/3.3/Core/Tokens/NullReferenceToken.cs	(revision 8446)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Persistence.Core.Tokens {
+
+  /// <summary>
+  /// Describes a reference to <c>null</c>.
+  /// </summary>
+  public class NullReferenceToken : SerializationTokenBase {
+
+    /// <summary>
+    /// Initializes a new instance of the <see cref="NullReferenceToken"/> class.
+    /// </summary>
+    /// <param name="name">The token name.</param>
+    public NullReferenceToken(string name) : base(name) { }
+  }
+
+}
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.OneMax/3.3/OneMaxProblem.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.OneMax/3.3/OneMaxProblem.cs	(revision 8446)
+++ branches/HeuristicLab.Mono/HeuristicLab.Problems.OneMax/3.3/OneMaxProblem.cs	(revision 8446)
@@ -0,0 +1,199 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.BinaryVectorEncoding;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Problems.OneMax {
+  [Item("OneMax Problem", "Represents a OneMax Problem.")]
+  [Creatable("Problems")]
+  [StorableClass]
+  public sealed class OneMaxProblem : SingleObjectiveHeuristicOptimizationProblem<IOneMaxEvaluator, IBinaryVectorCreator>, IStorableContent {
+    public string Filename { get; set; }
+
+    #region Parameter Properties
+    public ValueParameter<IntValue> LengthParameter {
+      get { return (ValueParameter<IntValue>)Parameters["Length"]; }
+    }
+    #endregion
+
+    #region Properties
+    public IntValue Length {
+      get { return LengthParameter.Value; }
+      set { LengthParameter.Value = value; }
+    }
+    private BestOneMaxSolutionAnalyzer BestOneMaxSolutionAnalyzer {
+      get { return Operators.OfType<BestOneMaxSolutionAnalyzer>().FirstOrDefault(); }
+    }
+    #endregion
+
+    // BackwardsCompatibility3.3
+    #region Backwards compatible code, remove with 3.4
+    [Obsolete]
+    [Storable(Name = "operators")]
+    private IEnumerable<IOperator> oldOperators {
+      get { return null; }
+      set {
+        if (value != null && value.Any())
+          Operators.AddRange(value);
+      }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private OneMaxProblem(bool deserializing) : base(deserializing) { }
+    private OneMaxProblem(OneMaxProblem original, Cloner cloner)
+      : base(original, cloner) {
+      RegisterEventHandlers();
+    }
+    public OneMaxProblem()
+      : base(new OneMaxEvaluator(), new RandomBinaryVectorCreator()) {
+      Parameters.Add(new ValueParameter<IntValue>("Length", "The length of the BinaryVector.", new IntValue(5)));
+
+      Maximization.Value = true;
+      MaximizationParameter.Hidden = true;
+      BestKnownQuality = new DoubleValue(5);
+
+      SolutionCreator.BinaryVectorParameter.ActualName = "OneMaxSolution";
+      Evaluator.QualityParameter.ActualName = "NumberOfOnes";
+      ParameterizeSolutionCreator();
+      ParameterizeEvaluator();
+
+      InitializeOperators();
+      RegisterEventHandlers();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OneMaxProblem(this, cloner);
+    }
+
+    #region Events
+    protected override void OnSolutionCreatorChanged() {
+      base.OnSolutionCreatorChanged();
+      SolutionCreator.BinaryVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_BinaryVectorParameter_ActualNameChanged);
+      ParameterizeSolutionCreator();
+      ParameterizeEvaluator();
+      ParameterizeAnalyzer();
+      ParameterizeOperators();
+    }
+    protected override void OnEvaluatorChanged() {
+      base.OnEvaluatorChanged();
+      ParameterizeEvaluator();
+      ParameterizeAnalyzer();
+    }
+    private void SolutionCreator_BinaryVectorParameter_ActualNameChanged(object sender, EventArgs e) {
+      ParameterizeEvaluator();
+      ParameterizeAnalyzer();
+      ParameterizeOperators();
+    }
+    private void LengthParameter_ValueChanged(object sender, EventArgs e) {
+      ParameterizeSolutionCreator();
+      LengthParameter.Value.ValueChanged += new EventHandler(Length_ValueChanged);
+      BestKnownQualityParameter.Value.Value = Length.Value;
+    }
+    private void Length_ValueChanged(object sender, EventArgs e) {
+      BestKnownQualityParameter.Value.Value = Length.Value;
+    }
+    private void BestKnownQualityParameter_ValueChanged(object sender, EventArgs e) {
+      BestKnownQualityParameter.Value.Value = Length.Value;
+    }
+    private void OneBitflipMoveParameter_ActualNameChanged(object sender, EventArgs e) {
+      string name = ((ILookupParameter<OneBitflipMove>)sender).ActualName;
+      foreach (IOneBitflipMoveOperator op in Operators.OfType<IOneBitflipMoveOperator>()) {
+        op.OneBitflipMoveParameter.ActualName = name;
+      }
+    }
+    #endregion
+
+    #region Helpers
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (Operators.Count == 0) InitializeOperators();
+      #endregion
+      RegisterEventHandlers();
+    }
+
+    private void RegisterEventHandlers() {
+      SolutionCreator.BinaryVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_BinaryVectorParameter_ActualNameChanged);
+      LengthParameter.ValueChanged += new EventHandler(LengthParameter_ValueChanged);
+      LengthParameter.Value.ValueChanged += new EventHandler(Length_ValueChanged);
+      BestKnownQualityParameter.ValueChanged += new EventHandler(BestKnownQualityParameter_ValueChanged);
+    }
+
+    private void ParameterizeSolutionCreator() {
+      SolutionCreator.LengthParameter.ActualName = LengthParameter.Name;
+    }
+    private void ParameterizeEvaluator() {
+      if (Evaluator is OneMaxEvaluator)
+        ((OneMaxEvaluator)Evaluator).BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
+    }
+    private void ParameterizeAnalyzer() {
+      BestOneMaxSolutionAnalyzer.MaximizationParameter.ActualName = MaximizationParameter.Name;
+      BestOneMaxSolutionAnalyzer.BestKnownQualityParameter.ActualName = BestKnownQualityParameter.Name;
+      BestOneMaxSolutionAnalyzer.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
+      BestOneMaxSolutionAnalyzer.ResultsParameter.ActualName = "Results";
+    }
+    private void InitializeOperators() {
+      Operators.Add(new BestOneMaxSolutionAnalyzer());
+      ParameterizeAnalyzer();
+      foreach (IBinaryVectorOperator op in ApplicationManager.Manager.GetInstances<IBinaryVectorOperator>()) {
+        if (!(op is ISingleObjectiveMoveEvaluator) || (op is IOneMaxMoveEvaluator)) {
+          Operators.Add(op);
+        }
+      }
+      ParameterizeOperators();
+      InitializeMoveGenerators();
+    }
+    private void InitializeMoveGenerators() {
+      foreach (IOneBitflipMoveOperator op in Operators.OfType<IOneBitflipMoveOperator>()) {
+        if (op is IMoveGenerator) {
+          op.OneBitflipMoveParameter.ActualNameChanged += new EventHandler(OneBitflipMoveParameter_ActualNameChanged);
+        }
+      }
+    }
+    private void ParameterizeOperators() {
+      foreach (IBinaryVectorCrossover op in Operators.OfType<IBinaryVectorCrossover>()) {
+        op.ParentsParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
+        op.ChildParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
+      }
+      foreach (IBinaryVectorManipulator op in Operators.OfType<IBinaryVectorManipulator>()) {
+        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
+      }
+      foreach (IBinaryVectorMoveOperator op in Operators.OfType<IBinaryVectorMoveOperator>()) {
+        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
+      }
+      foreach (var op in Operators.OfType<IBinaryVectorMultiNeighborhoodShakingOperator>())
+        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
+    }
+    #endregion
+  }
+}
Index: branches/HeuristicLab.Mono/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs
===================================================================
--- branches/HeuristicLab.Mono/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs	(revision 8445)
+++ 	(revision )
@@ -1,199 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-using HeuristicLab.Data;
-using HeuristicLab.Encodings.BinaryVectorEncoding;
-using HeuristicLab.Optimization;
-using HeuristicLab.Parameters;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.Problems.OneMax {
-  [Item("OneMax Problem", "Represents a OneMax Problem.")]
-  [Creatable("Problems")]
-  [StorableClass]
-  public sealed class OneMaxProblem : SingleObjectiveHeuristicOptimizationProblem<IOneMaxEvaluator, IBinaryVectorCreator>, IStorableContent {
-    public string Filename { get; set; }
-
-    #region Parameter Properties
-    public ValueParameter<IntValue> LengthParameter {
-      get { return (ValueParameter<IntValue>)Parameters["Length"]; }
-    }
-    #endregion
-
-    #region Properties
-    public IntValue Length {
-      get { return LengthParameter.Value; }
-      set { LengthParameter.Value = value; }
-    }
-    private BestOneMaxSolutionAnalyzer BestOneMaxSolutionAnalyzer {
-      get { return Operators.OfType<BestOneMaxSolutionAnalyzer>().FirstOrDefault(); }
-    }
-    #endregion
-
-    // BackwardsCompatibility3.3
-    #region Backwards compatible code, remove with 3.4
-    [Obsolete]
-    [Storable(Name = "operators")]
-    private IEnumerable<IOperator> oldOperators {
-      get { return null; }
-      set {
-        if (value != null && value.Any())
-          Operators.AddRange(value);
-      }
-    }
-    #endregion
-
-    [StorableConstructor]
-    private OneMaxProblem(bool deserializing) : base(deserializing) { }
-    private OneMaxProblem(OneMaxProblem original, Cloner cloner)
-      : base(original, cloner) {
-      RegisterEventHandlers();
-    }
-    public OneMaxProblem()
-      : base(new OneMaxEvaluator(), new RandomBinaryVectorCreator()) {
-      Parameters.Add(new ValueParameter<IntValue>("Length", "The length of the BinaryVector.", new IntValue(5)));
-
-      Maximization.Value = true;
-      MaximizationParameter.Hidden = true;
-      BestKnownQuality = new DoubleValue(5);
-
-      SolutionCreator.BinaryVectorParameter.ActualName = "OneMaxSolution";
-      Evaluator.QualityParameter.ActualName = "NumberOfOnes";
-      ParameterizeSolutionCreator();
-      ParameterizeEvaluator();
-
-      InitializeOperators();
-      RegisterEventHandlers();
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new OneMaxProblem(this, cloner);
-    }
-
-    #region Events
-    protected override void OnSolutionCreatorChanged() {
-      base.OnSolutionCreatorChanged();
-      SolutionCreator.BinaryVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_BinaryVectorParameter_ActualNameChanged);
-      ParameterizeSolutionCreator();
-      ParameterizeEvaluator();
-      ParameterizeAnalyzer();
-      ParameterizeOperators();
-    }
-    protected override void OnEvaluatorChanged() {
-      base.OnEvaluatorChanged();
-      ParameterizeEvaluator();
-      ParameterizeAnalyzer();
-    }
-    private void SolutionCreator_BinaryVectorParameter_ActualNameChanged(object sender, EventArgs e) {
-      ParameterizeEvaluator();
-      ParameterizeAnalyzer();
-      ParameterizeOperators();
-    }
-    private void LengthParameter_ValueChanged(object sender, EventArgs e) {
-      ParameterizeSolutionCreator();
-      LengthParameter.Value.ValueChanged += new EventHandler(Length_ValueChanged);
-      BestKnownQualityParameter.Value.Value = Length.Value;
-    }
-    private void Length_ValueChanged(object sender, EventArgs e) {
-      BestKnownQualityParameter.Value.Value = Length.Value;
-    }
-    private void BestKnownQualityParameter_ValueChanged(object sender, EventArgs e) {
-      BestKnownQualityParameter.Value.Value = Length.Value;
-    }
-    private void OneBitflipMoveParameter_ActualNameChanged(object sender, EventArgs e) {
-      string name = ((ILookupParameter<OneBitflipMove>)sender).ActualName;
-      foreach (IOneBitflipMoveOperator op in Operators.OfType<IOneBitflipMoveOperator>()) {
-        op.OneBitflipMoveParameter.ActualName = name;
-      }
-    }
-    #endregion
-
-    #region Helpers
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      // BackwardsCompatibility3.3
-      #region Backwards compatible code (remove with 3.4)
-      if (Operators.Count == 0) InitializeOperators();
-      #endregion
-      RegisterEventHandlers();
-    }
-
-    private void RegisterEventHandlers() {
-      SolutionCreator.BinaryVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_BinaryVectorParameter_ActualNameChanged);
-      LengthParameter.ValueChanged += new EventHandler(LengthParameter_ValueChanged);
-      LengthParameter.Value.ValueChanged += new EventHandler(Length_ValueChanged);
-      BestKnownQualityParameter.ValueChanged += new EventHandler(BestKnownQualityParameter_ValueChanged);
-    }
-
-    private void ParameterizeSolutionCreator() {
-      SolutionCreator.LengthParameter.ActualName = LengthParameter.Name;
-    }
-    private void ParameterizeEvaluator() {
-      if (Evaluator is OneMaxEvaluator)
-        ((OneMaxEvaluator)Evaluator).BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
-    }
-    private void ParameterizeAnalyzer() {
-      BestOneMaxSolutionAnalyzer.MaximizationParameter.ActualName = MaximizationParameter.Name;
-      BestOneMaxSolutionAnalyzer.BestKnownQualityParameter.ActualName = BestKnownQualityParameter.Name;
-      BestOneMaxSolutionAnalyzer.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
-      BestOneMaxSolutionAnalyzer.ResultsParameter.ActualName = "Results";
-    }
-    private void InitializeOperators() {
-      Operators.Add(new BestOneMaxSolutionAnalyzer());
-      ParameterizeAnalyzer();
-      foreach (IBinaryVectorOperator op in ApplicationManager.Manager.GetInstances<IBinaryVectorOperator>()) {
-        if (!(op is ISingleObjectiveMoveEvaluator) || (op is IOneMaxMoveEvaluator)) {
-          Operators.Add(op);
-        }
-      }
-      ParameterizeOperators();
-      InitializeMoveGenerators();
-    }
-    private void InitializeMoveGenerators() {
-      foreach (IOneBitflipMoveOperator op in Operators.OfType<IOneBitflipMoveOperator>()) {
-        if (op is IMoveGenerator) {
-          op.OneBitflipMoveParameter.ActualNameChanged += new EventHandler(OneBitflipMoveParameter_ActualNameChanged);
-        }
-      }
-    }
-    private void ParameterizeOperators() {
-      foreach (IBinaryVectorCrossover op in Operators.OfType<IBinaryVectorCrossover>()) {
-        op.ParentsParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
-        op.ChildParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
-      }
-      foreach (IBinaryVectorManipulator op in Operators.OfType<IBinaryVectorManipulator>()) {
-        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
-      }
-      foreach (IBinaryVectorMoveOperator op in Operators.OfType<IBinaryVectorMoveOperator>()) {
-        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
-      }
-      foreach (var op in Operators.OfType<IBinaryVectorMultiNeighborhoodShakingOperator>())
-        op.BinaryVectorParameter.ActualName = SolutionCreator.BinaryVectorParameter.ActualName;
-    }
-    #endregion
-  }
-}
